' modified version of plasma used to tile water
DIM cosinus%(640)
position& = 0
FOR c% = 0 TO 640
    cosinus%(c%) = COS(2 * 3.14159265358# * c% / 320) * 32 + 32
NEXT c%
COLOR 4
PRINT "Raycasting Water-Demo"
PRINT
PRINT "It's hardly recommended to run this demo compiled. Use arrows to nav."
PRINT "press b to toggle bumpmapping off/on. Press esc to exit."
PRINT
PRINT "Press any key to start demo"
WHILE ein$ <> ""
ein$ = INKEY$
WEND
WHILE ein$ = ""
ein$ = INKEY$
WEND
SCREEN 13
OUT &H3C8, 0
FOR c = 0 TO 31
    r% = 40 - c * 3
    IF r% < 0 THEN r% = 0
    OUT &H3C9, r% '/ 2
    g% = 48 - (c * 1)
    IF g% < 0 THEN g% = 0
    OUT &H3C9, g% '/ 2
    OUT &H3C9, (48 - (c)) '/ 2
NEXT
FOR c = 31 TO 0 STEP -1
    r% = 40 - c * 3
    IF r% < 0 THEN r% = 0
    OUT &H3C9, r% '/ 2
    g% = 48 - (c * 1)
    IF g% < 0 THEN g% = 0
    OUT &H3C9, g% '/ 2
    OUT &H3C9, (48 - (c)) '/ 2
NEXT
'.-.-.-.-.
' rayfast2.bas version 1.01 by dieter marfurt
' version with &hffff& -multiplyer , floor texture, poke-instead of line
' ,"peek-division" used to determine texture-position and wall-height,
' and height-table.
' this one is pretty fast but hard to read...

'use the numeric keys to navigate.
'you might replace the keyboardhandler - it really sucks now if not compiled

SCREEN 13
DIM Grid%(13, 13)

DIM t10%(320)
FOR i% = 0 TO 320
 t10%(i%) = i% / 10
NEXT i%

DIM t320&(200)
FOR i& = 0 TO 200
t320&(i&) = i& * 320
NEXT i&

DIM half%(255) 'used to divide tru 2 fast
FOR i% = 0 TO 255
 half%(i%) = i% \ 2
NEXT i%

DIM tex%(127, 127) 'texture
 
DIM xxyyt&(500) ' divider-table
FOR i% = 0 TO 500
 xxyyt&(i%) = &HFFFF& + 1
 xxyyt&(i%) = xxyyt&(i%) * i%
NEXT i%

DIM hht%(2000)' height-table
FOR i% = 1 TO 2000      '-9000  80*
 hht%(i%) = ((-3000& + (64& * (hh% + 150))) \ i%)' AND &HEFFF
NEXT i%

REDIM SHARED STable!(-192 TO 1992), CTable!(-192 TO 1992)
REDIM SHARED iSTable%(-192 TO 1992), iCTable%(-192 TO 1992)
PX& = 150000: PY& = 150000 ' start position
' init fast peek-division
XX& = 0: YY& = 0: txx2& = 0: tyy2& = 0
xxseg% = VARSEG(XX&)
yyseg% = VARSEG(YY&)
xxptr% = VARPTR(XX&) + 2
yyptr% = VARPTR(YY&) + 2

txxseg% = VARSEG(txx2&)
tyyseg% = VARSEG(tyy2&)
txxptr% = VARPTR(txx2&) + 1
tyyptr% = VARPTR(tyy2&) + 1


Stride2% = 3
Heading% = 980
Turn% = 30
 
FOR Y% = 1 TO 12
  FOR X% = 1 TO 12
    READ Grid%(X%, Y%)
  NEXT
NEXT

Factor! = (ATN(1) * 8) / 1800
FOR a% = 0 TO 1799
  Angle! = CSNG(a%) * Factor!
  STable!(a%) = SIN(Angle!) * .1
  CTable!(a%) = COS(Angle!) * .1
NEXT
FOR a% = 1800 TO 1800 + 192
  STable!(a%) = STable!(a% - 1800)
  CTable!(a%) = CTable!(a% - 1800)
NEXT
FOR a% = 0 TO -192 STEP -1
  STable!(a%) = STable!(a% + 1800)
  CTable!(a%) = CTable!(a% + 1800)
NEXT
FOR a% = -192 TO 1992
  iSTable%(a%) = STable!(a%) * &HFFFF&
  iCTable%(a%) = CTable!(a%) * &HFFFF&
NEXT a%
REDIM SHARED STable!(0), CTable!(0)

PALETTE 0, 0
'bumptoggle% = 1
DO '.....................................   Main loop !!!!
GOSUB water
 z% = z% + 1
 IF z% >= 100 THEN
  z% = 0
  t2# = 101 / (TIMER - t#)
  t# = TIMER
 END IF
 aa% = INP(&H60)
 a$ = INKEY$
 IF aa% <> 0 THEN
  IF a$ = "b" THEN
   bumptoggle% = bumptoggle% XOR 1
  END IF
  IF aa% = 75 THEN                    'turn left
    Heading% = (Heading% + Turn%) MOD 1800
   ' GOSUB ComputeView
  END IF
  IF aa% = 77 THEN                    'turn right
    Heading% = (Heading% + (1800 - Turn%)) MOD 1800
   ' GOSUB ComputeView
  END IF
  IF aa% = 72 THEN                    'walk forward
    NewPX& = PX& - (iSTable%(Heading%) * Stride2%)
    NewPY& = PY& - (iCTable%(Heading%) * Stride2%)
    IF Grid%(NewPX& \ &HFFFF&, NewPY& \ &HFFFF&) <> 15 THEN
      PX& = NewPX&: PY& = NewPY&
    '  GOSUB ComputeView
    ELSE 'tried to walk through a wall
      SOUND 80, 1
    END IF
  END IF
  IF aa% = 80 THEN                    'walk back
    NewPX& = PX& + (iSTable%(Heading%) * Stride2%)
    NewPY& = PY& + (iCTable%(Heading%) * Stride2%)
    IF Grid%(NewPX& \ &HFFFF&, NewPY& \ &HFFFF&) <> 15 THEN
      PX& = NewPX&: PY& = NewPY&
      'GOSUB ComputeView
    ELSE 'tried to walk through a wall
      SOUND 80, 1
    END IF
  END IF
 END IF
 GOSUB ComputeView
  LOCATE 20, 20
  PRINT "FPS: "; INT(t2#); " ";
LOOP UNTIL aa% = 1 'a$ = CHR$(27)
END '.. ......eo mainloop

ComputeView:
x1% = 0
FOR a% = Heading% + 160 TO Heading% - 159 STEP -1
  XX& = PX&: YY& = PY&
  l% = 0
  floorold% = 199
  stepx% = iSTable%(a%) \ 5: stepy% = iCTable%(a%) \ 5
  DEF SEG = xxseg%
   '***************************************************************************
  DO
    XX& = XX& - stepx%: YY& = YY& - stepy%
     l% = l% + 2
     xg% = PEEK(xxptr%)
     yg% = PEEK(yyptr%)
     txx2& = (XX& - xxyyt&(xg%))
     tyy2& = (YY& - xxyyt&(yg%))
     txx% = half%(PEEK(txxptr%))
     tyy% = half%(PEEK(tyyptr%))
     c% = tex%(txx%, tyy%)
     k% = Grid%(xg%, yg%)
     IF bumptoggle% THEN
      IF k% THEN
       dd% = hht%(l% + 50)
       c% = k%
      ELSE
      'bump& = (1 / 256) * l% * (tex%(txx%, tyy%)) 'too slow...
       dd% = hht%(32 + l% - half%(tex%(txx%, tyy%)))
      END IF
     ELSE
      IF k% THEN
       dd% = hht%(l% + 50)
       c% = k%
      ELSE
       dd% = hht%(l%)
      END IF
     END IF
     floor% = 100 + dd%
     IF floor% < floorold% THEN
      DEF SEG = &HA000
      FOR i% = floor% TO floorold%
       POKE t320&(i%) + x1%, c%
      NEXT i%
      'LINE (x1%, floor%)-(x1%, floorold%), c%, B
      floorold% = floor%
      DEF SEG = xxseg%
     END IF
   LOOP UNTIL k% = 15
  '***************************************************************************
     dd% = hht%(l%)
  DEF SEG = &HA000
  roof% = 100 - dd%
  'LINE (x1%, roof%)-(x1%, floor%), k%, B
      FOR i% = roof% TO floor%
      IF i% >= 0 AND i% <= 199 THEN
       POKE t320&(i%) + x1%, k% + 128
      END IF
      NEXT i%
     'LINE (x1%, 0)-(x1%, roof%), 0, B
    IF roof% >= 0 THEN
      FOR i% = 0 TO roof%
       POKE t320&(i%) + x1%, 76
      NEXT i%
    END IF
  'LINE (x1%, floor%)-(x1%, 199), 0, B
            
  x1% = x1% + 1
            
NEXT a%
RETURN
 ' Level data for Grid%(,)
DATA 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15
DATA 15,  0,  0,  0,  0,  0,  0,  0,  0,114,  0, 15
DATA 15,  0,160,160,160,160,160,  0,  0,122,  0, 15
DATA 15,  0,110,112,  0,  0,160,  0,  0,111,  0, 15
DATA 15,  0,  0,  0,  0,  0,160,  0,  0,132,  0, 15
DATA 15,  0,  0,  0,  0,177,177,  0,  0,  0,  0, 15
DATA 15,  0,  0,  0,  0,177,117,  0,  0,  0,  0, 15
DATA 15,  0,113,  0,  0,  0,  0,108,  0,122,  0, 15
DATA 15,  0,115,  0,  0,  0,  0,117,  0,124,  0, 15
DATA 15,  0,113,  0,  0,  0,  0,128,  0,112,  0, 15
DATA 15,  0,115,  0,  0,  0,  0,117,  0,114,  0, 15
DATA 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15


'this routine generates a tile-able 32*32 Pixel water-effect
water:
    wave1% = wave1% + 20
    IF wave1% >= 320 THEN wave1% = 0 '320
    wave2% = wave2% + 4
    IF wave2% >= 320 THEN wave2% = 0
    wave3% = wave3% + 4
    IF wave3% >= 320 THEN wave3% = 0
     FOR Y% = 0 TO 319 STEP 10
     y10% = t10%(Y%)
        d% = cosinus%(Y% + wave2%) + cosinus%(Y% + wave3%)
        FOR X% = 0 TO 319 STEP 10
         f% = 1 + ABS(((cosinus%(X% + wave1%) + cosinus%(X% + Y%) + d%) / 8) - 16)
x10% = t10%(X%)
'PSET (x10%, y10%), f%
'PSET (32 + x10%, y10%), f%
'PSET (x10%, 32 + y10%), f%
'PSET (32 + x10%, 32 + y10%), f%
FOR j% = 0 TO 127 STEP 32
 FOR i% = 0 TO 127 STEP 32
  tex%(x10% + i%, y10% + j%) = f%
  'writin plasma(32*32) straight to texture (128*128)
 NEXT i%
NEXT j%
 NEXT X%
    NEXT Y%
'    PALETTE 0, 0
'    i$ = INKEY$
'    IF i$ <> "" THEN END
RETURN

